	PROGRAM TEST

C  THIS PROGRAM TESTS ALL THE AVAILABLE ROUTINES FOR WATER/VAPOUR SYS.

	IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION DVDHCP(50),DVDPCH(50),DVDPCS(50),DVDTCP(50),DPDTCV(50),
     *DPDVCT(50),DPDVCS(50),DSDTCV(50),DSDPCT(50),DSDPCV(50),DSDVCP(50),
     *DHDPCT(50),DHDTCP(50),DHDVCT(50),DHDPCV(50),DTDPCH(50),
     *ACOVEL(50),CV(50),GAMMA(50)


	COMMON /CONST5/ ZZZ0,ZZZ1,ZZZ2,ZZZ3,ZZZ4,ZZZ5,ZZZ6,ZZZ7,ZZZ8,
     *	ZZZ9,ZZZE2,ZZZE3,ZZZE4,ZZZE5,ZZZE6,ZZZM2,ZZZM3,ZZZM4,ZZZM5,
     *	ZZZM6,ZZZ01,ZZZ10,ZZZ273,ZZZ314,ZZZ981,ZZZER

	COMMON /WASPR5/ F1,F2,F11,F12,F22,F21,TES1,TES2,TNEW,VNEW,TOLD,
     *                  VOLD,POLD,IS2

	CHARACTER TEXT1(7)*56, TEXT2(2,7)*3, TEXT3(7)*6


      	DATA TEXT1 /
     *  ' Enter Pressure (Pa) & Internal Energy (j/kg)  P,U =',
     *	' Enter Pressure (Pa) & Entropy (j/kg K)   P,S = ',
     *	' Enter Enthalpy (j/kg) & Pressure (Pa)   H,P = ',
     *	' Enter Pressure (Pa) & Temperature (Deg.C)   P,T = ',
     *	' Enter Pressure (Pa) & Volume (m3/kg)   P,V  = ',
     *	' Enter Enthalpy (j/kg) & Volume (m3/kg)   H,V = ',
     *	' Enter Internal Energy (j/kg) & Volume (m3/kg)   U,V = '/

	DATA TEXT2 /'P=','U=','P=','S=','H=','P=','P=','T=','P=','V=',
     *              'H=','V=','U=','V=' /
	
	DATA TEXT3 /'WASPU1','WASPS1','WASHP1','WASPT1','WASPV1',
     *              'WASHV1','WASUV1' /

      WRITE(*,'(A\)')'       3-  LPT1:       4- b:anyfilename          '

	OPEN (3,FILE=' ',STATUS='NEW')
        OPEN (4,FILE=' ',STATUS='NEW')

        WRITE(4,44)

	DO 30 I=1,50

	WRITE (*,20)
20	FORMAT (/,10X,'SELECT ONE',//,
     *            10X,'1-WASPU1',/,
     *            10X,'2-WASPS1',/,
     *            10X,'3-WASHP1',/,
     *            10X,'4-WASPT1',/,
     *            10X,'5-WASPV1',/,
     *            10X,'6-WASHV1',/,
     *            10X,'7-WASUV1',/)

	WRITE (*,'(A\)') '                    ENTER THE NUMBER PLEASE = '
	READ (*,*) K

	IF (K.LT.1 .OR. K.GT.7) GOTO 58


	WRITE (*,19)
 19	FORMAT (//////)

	WRITE (*,'(A\)') TEXT1(K)
	READ (*,*) VI1,VI2

	WRITE (*,19)

      WRITE (*,'(A\)') ' Enter L,  and Estimates of (T,V)    L,T,V = '
      READ (*,21) L,VO1,VO2
 21	FORMAT(I3,2F11.6)


	GOTO (1,2,3,4,5,6,7),K	

 1	CALL WASPU1 (VI1,VI2,VO1,VO2,Z,Z1,Z2,Z11,Z12,Z22,L)
	GOTO 25
 2	CALL WASPS1 (VI1,VI2,VO1,VO2,Z,Z1,Z2,Z11,Z12,Z22,L)
	GOTO 25
 3	CALL WASHP1 (VI1,VI2,VO1,VO2,Z,Z1,Z2,Z11,Z12,Z22,L)
	GOTO 25
 4	CALL WASPT1 (VI1,VI2,VO1,VO2,Z,Z1,Z2,Z11,Z12,Z22,L)
	GOTO 25
 5	CALL WASPV1 (VI1,VI2,VO1,VO2,Z,Z1,Z2,Z11,Z12,Z22,L)
	GOTO 25
 6	CALL WASHV1 (VI1,VI2,VO1,VO2,Z,Z1,Z2,Z11,Z12,Z22,L)
	GOTO 25
 7	CALL WASUV1 (VI1,VI2,VO1,VO2,Z,Z1,Z2,Z11,Z12,Z22,L)
C
 25	WRITE (3,26) TEXT3(K)
 26	FORMAT(/,10X,A,/,10X,'------',/)

   	WRITE (3,27) TEXT2(1,K),VI1,TEXT2(2,K),VI2,VO1,VO2,Z,Z1,Z2
 27	FORMAT (/,10X,2(A,E20.8,/,10X),/,10X,' T= ',E20.8,/,10X,
     *  ' V= ',E20.8,/,10X,' Z= ',E20.8,/,10X,
     *  '-S= ',E20.8,/,10X,'-P= ',E20.8,///)
C
C     -------------------------------
C     EVALUATION OF PARTIAL DERIVATES
C     -------------------------------
C
      ABSTEM=VO1+ZZZ273
      TDENOM=ABSTEM*(Z12*Z12-Z11*Z22)
C
C  DERIVATIVES OF VOLUME
C
      DVDHCP(I)=-Z12/TDENOM
      DVDPCH(I)=(ABSTEM*Z11+VO2*Z12)/TDENOM
      DVDPCS(I)=Z11*ABSTEM/TDENOM
      DVDTCP(I)=-Z12/Z22
C
C  DERIVATIVES OF PRESSURE
C
      DPDTCV(I)=-Z12
      DPDVCT(I)=-Z22
      DPDVCS(I)=Z12*(Z12/Z11-Z22/Z12)
C
C  DERIVATIVES OF ENTROPY
C
      DSDTCV(I)=-Z11
      DSDPCT(I)=Z12/Z22
      DSDPCV(I)=Z11/Z12
      DSDVCP(I)=Z22*(Z11/Z12-Z12/Z22)
C
C  DERIVATIVES OF ENTHALPY
C
      DHDPCT(I)=VO2+ABSTEM*(Z12/Z22)
      DHDTCP(I)=TDENOM/Z22
      DHDVCT(I)=-(ABSTEM*Z12+VO2*Z22)
      DHDPCV(I)=ABSTEM*Z11/Z12+VO2
C
C  DERIVATIVES OF TEMPERATURE ; joule Thompson Coefficient
C
      DTDPCH(I)=-(ABSTEM*Z12/Z22+VO2)/DHDTCP(I) 	
C
C  ACOUSTIC VELOCITY
C
      ACOVEL(I)=DSQRT(VO2*VO2*Z12*(Z22/Z12-Z12/Z11))
C
C  HEAT CAPACITY AT CONSTANT VOLUME Cv
C
      CV(I)=ABSTEM*DSDTCV(I)
C
C  ISENTROPIC EXPANSION COEFFICIENT
C
      GAMMA(I)=(DPDVCS(I)/Z2)*VO2
C
C
C-------------------------------------------
C
C
      WRITE(3,40) Z,Z1,Z2,Z11,Z12,Z22
      WRITE(3,42) DVDHCP(I),DVDPCH(I),DVDPCS(I),DVDTCP(I),DPDTCV(I),
     *DPDVCT(I),DPDVCS(I),DSDTCV(I),DSDPCT(I),DSDPCV(I),DSDVCP(I),
     *DHDPCT(I),DHDTCP(I),DHDVCT(I),DHDPCV(I),DTDPCH(I),ACOVEL(I),CV(I),
     *GAMMA(I)
  40  FORMAT(/,10X,'Z  = ',E20.8,/,10X,
     *             'Z1 = ',E20.8,/,10X,
     *             'Z2 = ',E20.8,/,10X,
     *             'Z11= ',E20.8,/,10X,
     *             'Z12= ',E20.8,/,10X,
     *             'Z22= ',E20.8,/,10X,///)
  42  FORMAT(10X,'DVDHCP= ',E20.8,/,10X,
     *           'DVDPCH= ',E20.8,/,10X,
     *           'DVDPCS= ',E20.8,/,10X,
     *           'DVDTCP= ',E20.8,/,10X,
     *           'DPDTCV= ',E20.8,/,10X,
     *           'DPDVCT= ',E20.8,/,10X,
     *           'DPDVCS= ',E20.8,/,10X,
     *           'DSDTCV= ',E20.8,/,10X,
     *           'DSDPCT= ',E20.8,/,10X,
     *           'DSDPCV= ',E20.8,/,10X,
     *           'DSDVCP= ',E20.8,/,10X,
     *           'DHDPCT= ',E20.8,/,10X,
     *           'DHDTCP= ',E20.8,/,10X,
     *           'DHDVCT= ',E20.8,/,10X,
     *           'DHDPCV= ',E20.8,/,10X,
     *           'DTDPCH= ',E20.8,/,10X,
     *           'ACOVEL= ',E20.8,/,10X,
     *           'CV    = ',E20.8,/,10X,
     *           'GAMMA = ',E20.8,/,10X,///)
C
C=====================formatting section==============================

 44   FORMAT(1X,'    VO1      VO2        Z           Z1            Z2 
     *      Z11      Z12       Z22',//)
 
 46   FORMAT(1X,'  DVDHCP    DVDPCH    DVDPCS       DVDTCP       DPDTCV
     *    DPDVCT       DPDVCS      DSDTCV',//)

 48   FORMAT(1X,'  DSDPCT    DSDPCV    DSDVCP       DHDPCT       DHDTCP
     *    DHDVCT      DHDPCV       DTDPCH',//)

 49   FORMAT(1X,'   ACOUSTIC VELOCITY           CV       ISENTROPIC 
     *EXPANSION COEFF.',//)

 50   FORMAT(8(E21.12,1X))

 52   FORMAT(8(E21.12,1X))
C=====================================================================
C
      WRITE(4,50) VO1,VO2,Z,Z1,Z2,Z11,Z12,Z22
C
 30   CONTINUE
 58   WRITE(4,46)
      DO 54 KK=1,I
      WRITE(4,52) DVDHCP(KK),DVDPCH(KK),DVDPCS(KK),DVDTCP(KK),
     *DPDTCV(KK),DPDVCT(KK),DPDVCS(KK),DSDTCV(KK)
 54   CONTINUE     
      WRITE(4,48)
      DO 56 KK=1,I
      WRITE(4,52) DSDPCT(KK),DSDPCV(KK),DSDVCP(KK),DHDPCT(KK),
     *DHDTCP(KK),DHDVCT(KK),DHDPCV(KK),DTDPCH(KK)
 56   CONTINUE
      WRITE(4,49)
      DO 60 KK=1,I
      WRITE(4,52) ACOVEL(KK),CV(KK),GAMMA(KK)
 60   CONTINUE

      CLOSE(4)
 99   STOP
      END 